/*
 * FILE:
 *   ConsoleLibCallbacks.cs
 *
 * PURPOSE:
 *   Implementation of VM callbacks for ConsoleLib
 *
 * AUTHOR:
 *   Stephen Thompson <stephen@solarflare.org.uk>
 *
 * CREATED:
 *   9-Jun-2011
 *
 * COPYRIGHT:
 *   Copyright (C) Stephen Thompson, 2011.
 *
 *   This file is part of Mips2cs. Mips2cs is distributed under the terms
 *   of the Boost Software License, Version 1.0, the text of which
 *   appears below.
 *
 *   Boost Software License - Version 1.0 - August 17th, 2003
 *   
 *   Permission is hereby granted, free of charge, to any person or organization
 *   obtaining a copy of the software and accompanying documentation covered by
 *   this license (the "Software") to use, reproduce, display, distribute,
 *   execute, and transmit the Software, and to prepare derivative works of the
 *   Software, and to permit third-parties to whom the Software is furnished to
 *   do so, all subject to the following:
 *
 *   The copyright notices in the Software and this entire statement, including
 *   the above license grant, this restriction and the following disclaimer,
 *   must be included in all copies of the Software, in whole or in part, and
 *   all derivative works of the Software, unless such copies or derivative
 *   works are solely in the form of machine-executable object code generated by
 *   a source language processor.
 *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *   FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 *   SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 *   FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 *   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 *   DEALINGS IN THE SOFTWARE.
 *
 */

class ConsoleLibCallbacks : MipsCallbacks
{
    // int vm_write(const char *addr, int len)
    public int f_10(MipsVM mips, int a0, int a1, int a2, int a3)
    {
        for (int i = 0; i < a1; ++i)
        {
            int Byte = mips.ReadByteU(a0);
            a0++;
            if (Byte == 10)
            {
                System.Console.WriteLine();
            }
            else
            {
                System.Console.Write((char)Byte);
            }
        }
        return a1;
    }

    // int vm_read(char *addr, int len)
    public int f_14(MipsVM mips, int a0, int a1, int a2, int a3)
    {
        if (a1 == 0) return 0;   // zero sized read
        mips.WriteByte(a0, System.Console.Read());
        return 1;
    }
}
