# FILE:
#   delay_slot.s
#
# PURPOSE:	
#   Test that jr works correctly if the delay slot insn
#   modifies the register being jumped to.
#
# AUTHOR:
#   Stephen Thompson <stephen@solarflare.org.uk>
#
# CREATED:
#   12-Jun-2011
#
# COPYRIGHT:
#   Copyright (C) Stephen Thompson, 2011.
#
#   This file is part of Mips2cs. Mips2cs is distributed under the terms
#   of the Boost Software License, Version 1.0, the text of which
#   appears below.
#
#   Boost Software License - Version 1.0 - August 17th, 2003
#   
#   Permission is hereby granted, free of charge, to any person or organization
#   obtaining a copy of the software and accompanying documentation covered by
#   this license (the "Software") to use, reproduce, display, distribute,
#   execute, and transmit the Software, and to prepare derivative works of the
#   Software, and to permit third-parties to whom the Software is furnished to
#   do so, all subject to the following:
#
#   The copyright notices in the Software and this entire statement, including
#   the above license grant, this restriction and the following disclaimer,
#   must be included in all copies of the Software, in whole or in part, and
#   all derivative works of the Software, unless such copies or derivative
#   works are solely in the form of machine-executable object code generated by
#   a source language processor.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
#   SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
#   FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
#   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.


	.set noat
	.set noreorder
	.text


dotest:
	# Check that $t0 is pointing at failed. If not, jump to failed.
	la	$t1, failed
	bne	$t0, $t1, failed
	nop

	# Test passed
	la	$a0, msg_passed
	li	$a1, 7
	jal	16
	nop
	j	0
	nop

failed:
	la	$a0, msg_failed
	li	$a1, 7
	jal	16
	nop
	j	0
	nop
	
	
_start:
.global _start
	la	$t0, dotest

	# Modify $t0 to point at failed in the delay slot.
	# This should not influence the branch (which should still go to dotest)
	# but it should leave $t0 pointing at failed when we enter dotest.
	jr	$t0
	addiu	$t0, $t0, (failed-dotest)

	nop

	
	.data
msg_passed:	.ascii "passed\n "
msg_failed:	.ascii "failed\n "
